"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.downloadStream = exports.download = void 0;
const s3Config_1 = require("../config/s3Config");
const fileHelperFunctions_1 = require("../utils/fileHelperFunctions");
const download = (input) => __awaiter(void 0, void 0, void 0, function* () {
    return new Promise((resolve, reject) => {
        const { Bucket, Key } = fileHelperFunctions_1.extractBucketKeyFromInput(input);
        s3Config_1.s3.getObject({
            Bucket: Bucket,
            Key: Key,
        })
            .promise()
            .then((result) => {
            if (result) {
                return resolve(result.Body);
            }
        })
            .catch((error) => {
            return reject(error);
        });
    });
});
exports.download = download;
const downloadStream = (input) => {
    const { Bucket, Key } = fileHelperFunctions_1.extractBucketKeyFromInput(input);
    const readableStream = s3Config_1.s3
        .getObject({
        Bucket: Bucket,
        Key: Key,
    })
        .createReadStream();
    return readableStream;
};
exports.downloadStream = downloadStream;
//# sourceMappingURL=download.js.map