"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.extractBucketKeyFromInput = void 0;
const extractBucketKeyFromInput = (input) => {
    let _bucket;
    let _key;
    if (input.url) {
        _bucket = input.url.split('.s3')[0].split('https://')[1];
        _key = input.url.split('amazonaws.com/')[1];
    }
    else {
        _bucket = input.Bucket;
        _key = input.Key;
    }
    if (!_bucket && !_key) {
        throw new Error('(url) or (bucket and key) should be provided');
    }
    else {
        return {
            Bucket: _bucket,
            Key: _key,
        };
    }
};
exports.extractBucketKeyFromInput = extractBucketKeyFromInput;
//# sourceMappingURL=fileHelperFunctions.js.map